/*
bcc32 -W main.cpp input.cpp sound.cpp graphics.cpp game.cpp CpAllObjFunc.cpp
*/

/*============================================================================
!CN[h
/*============================================================================*/
#include "../head/game2.h"

/*============================================================================
(nh)
//߂lFȂ
/*============================================================================*/
void InitGame(HWND hWnd)
{
    FILE *f_obj;

    CpAllObjFunc();
    _chdir("mukamuka");   //Lv1_2DPolygon(08)Ȑ

    f_obj=fopen("source/game.obj","r");
    if(f_obj!=NULL){
        fclose(f_obj);
#if BORLAND
        system("del *.sdf");
    	system("del source\\*.obj");
        system("del source\\*.tds");
        system("del debug\\*");
        remove("debug");
        rmdir("debug");
        
#endif
    }

#if MOTION
    main2(0);
    _chdir("mukamuka");   //Lv1_2DPolygon(08)Ȑ
#endif

    t_szbuf = (TCHAR*)malloc(sizeof(TCHAR)*MEMORY);   //i[pzm
    //XvCgpeNX`
    for(int i = 0; i < END_NUM_IMG; i++){
        g_pTexture_array[i] = NULL;
    }
#if BORLAND
    if(&hWnd == 0x0000) {}    //Borland ϐgpWarning΍
#endif

    //_}bv쐻
    mapsize = ( SCREEN_HEIGHT / (BLOCK_SIZE) ) ;    //}bv`bv
    //}bvTCY(`bv)؂ꂿAɂ
    if(mapsize % 2 == 0){
        mapsize--;
    }
    map = (int*)malloc( sizeof(int)*(mapsize * mapsize) );
    memset(map , 0 , sizeof(int)*(mapsize * mapsize) );
    mapCreate(MapPos);
    *(map + GoalPos.y * mapsize + GoalPos.x) = 2;   //S[ʒuݒ
    
}

/*============================================================================
I(Ȃ)
//߂lFȂ
/*============================================================================*/
void UninitGame(void)
{
    
    free(t_szbuf);    //i[pz
     
    // XvCgpeNX`̉
    for(int i = 0; i < END_NUM_IMG; i++){
        //Ă̂݉
        if(g_pTexture_array[i] != NULL){
        	SAFE_RELEASE(g_pTexture_array[i]);
        }
    }
}

/*============================================================================
XV(Ȃ)
//߂lFȂ
/*============================================================================*/
void Update(void)
{
    // ͏̍XV
	UpdateInput();

    if(stop_time_flg == false){
        cntFrame++;
    }
    switch(state){
        case TITLE: //^Cg---------------------------------------
            //܂߂ĂȂꍇ͑I\
            if(!decide_flg){
                //~[WbNX^[g
                if(!music_flg){
                    PlayMusic( BGM_TITLE , true );
                    music_flg = true;
                }

                PlayStart();
            }
            //߂ꍇ́Ȁuԉy~߁Aʉ
            else{
                wait_time_cnt++;
                //Pb҂
                if(wait_time_cnt % 60 == 0){
                    score = 0;
                    life = LIFE_INIT;
                    stage_num = STAGE1_IMG;
                    state = LOAD_STAGE;
                    decide_flg = 0;
                    bgm_no = BGM_STAGE1;
                }
            }
            break;

        case LOAD_STAGE:    //[hXe[W-------------------------
            wait_time_cnt++;
    
            //Rb҂
            if(wait_time_cnt % 180 == 0){
                //vCyĐ
                if(!music_flg){
                    PlayMusic( bgm_no , true );
                    music_flg = true;
                }
                //Gl~[̈ʒu𗓊O
                if(stage_num != STAGE5_IMG){
                    enemy[0] = -SELF_IMG_SIZE;
                    enemy[1] = -SELF_IMG_SIZE; //Gl~[ʒu*/
                }
                
                
                if(stage_num == STAGE1_IMG){
                    jiki_x = 32.0f;
                    jiki_y = 560.0f;
                }
                else if(stage_num == STAGE2_IMG){
                    jiki_x = 10.0f;
                    jiki_y = 30.0f;
                }
                else if(stage_num == STAGE_EX ){
                    jiki_x = 55.0f;
                    jiki_y = 105.0f;
                }
                else if(stage_num == STAGE4_IMG){
                    jiki_x = 64.0f;
                    jiki_y = 560.0f;
                }
                else if(stage_num == STAGE5_IMG){
                    jiki_x = 32.0f;
                    jiki_y = 560.0f;
                    
                    enemy[0] = (short)(SELF_IMG_SIZE*1.5);
                    enemy[1] = SCREEN_WIDTH - SELF_IMG_SIZE-1; //Gl~[ʒu*/
                }
                else if(stage_num == STAGE6_IMG){
                    jiki_x = 10.0f;
                    jiki_y = 10.0f;
                }
                
                s_ini_flg = false;
                state = STAGE;
            }
            break;
            
        case STAGE:        //Xe[W--------------------------------
            if(goal_flg == 0){
                hantei();
                if(stop_time_flg == false){
                    move();
                }
                else{
                    if( KEY(ENTER) ){
                        stop_time_flg = false;
                    }
                }
            }
            else{
                if(!music_flg){
                    PlayMusic( BGM_GOAL , false );
                    music_flg = true;
                }
                wait_time_cnt++;
                if(wait_time_cnt % (60 * 10) == 0){
                    decide_flg = 0;
                    end_show_score[ (int)( stage_num - STAGE1_IMG ) ] = (unsigned char)time_limit_val;
                    score += time_limit_val;
                    stage_num++;
                    bgm_no++;
                    if(stage_num > STAGE6_IMG ){
                        state = ENDING;
                    }
                    else{
                        state = LOAD_STAGE;
                    }
                    music_flg = false;
                    
                }
            }
            break;
            
        case DEATH: //~X------------------------------------------
            if(death_state == 0){
                if(wait_time_cnt % 60 == 0){
                    if( !music_flg){
                        PlayMusic( BGM_LOSE , true );
                        music_flg = true;
                    }
                    death_move();
                    if(jiki_y > 600){
                        wait_time_cnt = 1;
                        death_state = 1;
                    }
                }
                else{
                    wait_time_cnt++;
                }
            }
            else{
                wait_time_cnt++;
                if(wait_time_cnt % 60 == 0){
                    state = DEATH2;
                }
            }
            break;
            
        case DEATH2:    //~X--------------------------------------
            if(death_state == 2){
                wait_time_cnt++;
                if(wait_time_cnt % 30 == 0){
                    life--;
                    if(life < 0){
                        state = GAMEOVER;
                    }
                    else{
                        state = LOAD_STAGE;
                    }
                }
            }
            else{
                dying();
            }
            break;
            
        case GAMEOVER:  //Q[I[o[--------------------------------
            if(KEY(ENTER) || BUTTON_A){
                state = TITLE;
                decide_flg = 0;
            }
            break;
            
        case ENDING:
            
        default:
            break;
    }
}

/*============================================================================
`揈(Ȃ)
//߂lFȂ
/*============================================================================*/
void Draw(void)
{
    //^Cg̃obNJ[\
    if(state == TITLE)
    {
        // obNobt@yobt@̃NA
	    g_pD3DDevice->Clear(0, NULL, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(TITLE_BACK_COLOR_RED_VALUE, 
                                                                                         TITLE_BACK_COLOR_GREEN_VALUE, 
                                                                                         TITLE_BACK_COLOR_BLUE_VALUE, 0), 1.0f, 0);
        print_img(TOPTITLE , str_moji[TOPTITLE] , 0.0f , 800.0f , 0.0f ,  600.0f , 1.0f , 0.78125f);    //wi\
        print_img(TITLE_MOJI , str_moji[TITLE_MOJI] , 150.0f , 800.0f , 75.0f ,  128.0f , 1.0f , 1.0f);    //wi\
    }

    // Direct3Dɂ`̊Jn
	if(SUCCEEDED(g_pD3DDevice->BeginScene()))
	{
		// _tH[}bg̐ݒ
		g_pD3DDevice->SetFVF(FVF_VERTEX_2D);


        switch(state){
            
            //^Cg----------------------------------------------------------------------------------------------------------
            case TITLE:
                title();
                break;

            //[hXe[W--------------------------------------------------------------------------------------------------
            case LOAD_STAGE:
                stage_init();
                break;

            //Xe[W-------------------------------------------------------------------------------------------------------------
            case STAGE:
                if(stage_num != STAGE_EX){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 800.0f , 0.0f ,  600.0f , 0.78125f , 0.5859375f);    //wi\
                    if(stage_num == STAGE5_IMG){
                        print_img(FAIRY , str_moji[FAIRY] , enemy[1] , SELF_IMG_SIZE , enemy[0] ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //G\
                    }
                }
                else{
                    scroll_y = 0;
                    LoadAndDrowDot();
                }
                if(goal_flg == 1){
                    print_img(JIKI_GOAL , str_moji[JIKI_GOAL] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
                    wsprintf(t_szbuf , _T("GOAL!")  );
                    g_pD3DXFont_title->DrawText(NULL , t_szbuf , -1 , &rect[GOAL_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 128 , 0 , 255) );
                }
                else{
                    chara_anime();
                }
                time_limit();
                break;
            
            //~X------------------------------------------------------------------------------------------------------------------
            case DEATH:
                if(stage_num != STAGE_EX){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 800.0f , 0.0f ,  600.0f , 0.78125f , 0.5859375f);    //wi\
                    
                    //G\
                    if(stage_num == STAGE5_IMG){
                        print_img(FAIRY , str_moji[FAIRY] , enemy[1] , SELF_IMG_SIZE , enemy[0] ,  SELF_IMG_SIZE , 1.0f , 1.0f);
                    }
                }
                else{
                    scroll_y = 0;
                    LoadAndDrowDot();
                }
                
                print_img(JIKI_DEATH , str_moji[JIKI_DEATH] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
                time_limit();
                break;

            //~XQ-----------------------------------------------------------------------------------------------------------------
            case DEATH2:
                if(death_state != 2){
                    death2_screen();
                }
                else{
                    // obNobt@yobt@̃NA
	                g_pD3DDevice->Clear(0, NULL, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(0,0,0, 0), 1.0f, 0);
                }
                break;
            
            //Q[I[o[--------------------------------------------------------------------------------------------------------------
            case GAMEOVER:
                g_pD3DDevice->Clear(1, NULL, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(128, 0,255, 0), 1.0f, 0);
                print_img(JIKI_DEATH , str_moji[JIKI_DEATH] , 384.0f , SELF_IMG_SIZE , 240.0f ,  SELF_IMG_SIZE, 1.0f , 1.0f);
                g_pD3DXFont_normal->DrawText(NULL , _T("GAMEOVER") , -1 , &rect[10] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );
                
                break;
                
            //GfBO-----------------------------------------------------------------------------------------------------------------
            case ENDING:
            
                if(!music_flg){
                    show_score_cnt = 0;
                    PlayMusic( BGM_ENDING , false );
                    scroll_y = 600;
                    stage_num = STAGE1_IMG;
                    music_flg = true;
                    wait_time_cnt = 1;
                    sound_flg = false;
                    scroll_speedup_flg = false;
                    scroll_speed = 1;
                }
                // obNobt@yobt@̃NA
        	    g_pD3DDevice->Clear(0, NULL, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(255, 
                                                                                                 200, 
                                                                                                 200, 0), 1.0f, 0);
                if(stage_num == STAGE1_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 800.0f , scroll_y ,  600.0f , 0.78125f , 0.5859375f);    //wi\
                    g_pD3DXFont_normal->DrawText(NULL , _T("X^bt") , -1 , &rect[STUFFROLL1] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                }
                if(stage_num == STAGE2_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 800.0f , scroll_y ,  600.0f , 0.78125f , 0.5859375f);    //wi\
                    g_pD3DXFont_normal->DrawText(NULL , _T("EāEXyVAhoCU[") , -1 , &rect[STUFFROLL1] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                    g_pD3DXFont_normal->DrawText(NULL , _T("r") , -1 , &rect[STUFFROLL2] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                }
                if(stage_num == STAGE_EX){
                    LoadAndDrowDot();
                    g_pD3DXFont_normal->DrawText(NULL , _T("āEXe[W") , -1 , &rect[STUFFROLL1] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                    g_pD3DXFont_normal->DrawText(NULL , _T("@P") , -1 , &rect[STUFFROLL2] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                }
                if(stage_num == STAGE4_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 800.0f , scroll_y ,  600.0f , 0.78125f , 0.5859375f);    //wi\
                    g_pD3DXFont_normal->DrawText(NULL , _T("Xe[WECXg") , -1 , &rect[STUFFROLL1] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                    g_pD3DXFont_normal->DrawText(NULL , _T("amagimiroku") , -1 , &rect[STUFFROLL2] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                }
                if(stage_num == STAGE5_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 800.0f , scroll_y ,  600.0f , 0.78125f , 0.5859375f);    //wi\
                    print_img(FAIRY , str_moji[FAIRY] , 750.0f , SELF_IMG_SIZE , (float)(50+scroll_y) ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //G\
                    g_pD3DXFont_normal->DrawText(NULL , _T("vOETEh") , -1 , &rect[STUFFROLL1] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                    g_pD3DXFont_normal->DrawText(NULL , _T("bhtH[h") , -1 , &rect[STUFFROLL2] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                }
                if(stage_num == STAGE6_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 800.0f , scroll_y ,  600.0f , 0.78125f , 0.5859375f);    //wi\
                    g_pD3DXFont_normal->DrawText(NULL , _T("Presented by ...") , -1 , &rect[STUFFROLL1] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                    g_pD3DXFont_normal->DrawText(NULL , _T("`[A") , -1 , &rect[STUFFROLL2] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                }

                if(scroll_y < -600){
                    stage_num++;
                    scroll_y = 600;
                }
                else{
                    if(stage_num <= STAGE6_IMG){
                        scroll_y-=scroll_speed;
                        if(scroll_speedup_flg != true){
                            if(KEY(ENTER) || BUTTON_A){
                                scroll_speed *= 10;
                                scroll_speedup_flg = true;
                            }
                        }
                    }
                    else{
                        //print_img(STAGE_EX , str_moji[STAGE_EX] , 0.0f , 800.0f , 0.0f ,  600.0f , 0.78125f , 0.5859375f);    //GfBO摜
                    
                        if(show_score_cnt <= 6){
                            wait_time_cnt++;
                            if(wait_time_cnt % 60 == 0){
                                show_score_cnt++;
                                wait_time_cnt = 1;
                            }
                        }
                        if(show_score_cnt >= 1){
                            wsprintf(t_szbuf , _T("STAGE%d SCOREF%d") , 1 , end_show_score[1-1]);
                            g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[SHOWSCORE1_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                        }
                        if(show_score_cnt >= 2){
                            wsprintf(t_szbuf , _T("STAGE%d SCOREF%d") , 2 , end_show_score[2-1]);
                            g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[SHOWSCORE2_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                        }
                        if(show_score_cnt >= 3){
                            wsprintf(t_szbuf , _T("STAGE%d SCOREF%d") , 3 , end_show_score[3-1]);
                            g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[SHOWSCORE3_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                        }
                        if(show_score_cnt >= 4){
                            wsprintf(t_szbuf , _T("STAGE%d SCOREF%d") , 4 , end_show_score[4-1]);
                            g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[SHOWSCORE4_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                        }
                        if(show_score_cnt >= 5){
                            wsprintf(t_szbuf , _T("STAGE%d SCOREF%d") , 5 , end_show_score[5-1]);
                            g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[SHOWSCORE5_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                        }
                        if(show_score_cnt >= 6){
                            wsprintf(t_szbuf , _T("STAGE%d SCOREF%d") , 6 , end_show_score[6-1]);
                            g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[SHOWSCORE6_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                        }
                        
                        if(show_score_cnt == 7){
                            wait_time_cnt++;
                            if(wait_time_cnt % 60 == 0){
                                show_score_cnt++;
                                wait_time_cnt = 1;
                            }
                        }
                        if(show_score_cnt >= 8){
                            g_pD3DXFont_normal->DrawText(NULL , _T("SUMSCOREF") , -1 , &rect[SUMSCORE_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 255 , 255) );
                            wait_time_cnt++;
                            if(wait_time_cnt % 120 == 0){
                                show_score_cnt++;
                                wait_time_cnt = 1;
                            }
                        }
                        if(show_score_cnt >= 9){
                            if(sound_flg == false){
                                PlayMusic( SE_ENDSCORE , DMUS_SEGF_SECONDARY );
                                sound_flg = true;
                            }
                            wsprintf(t_szbuf , _T("%d") , score);
                            g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[SUMSCORENUM_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 200 , 0 , 255) );
                            
                            wait_time_cnt++;
                            if(wait_time_cnt % 180 == 0){
                                show_score_cnt++;
                                wait_time_cnt = 1;
                            }
                        }
                        if(show_score_cnt >=10 ){
                            g_pD3DXFont_normal->DrawText(NULL , _T("YOU WONI") , -1 , &rect[YOUWON_POS] , DT_LEFT , D3DCOLOR_RGBA(0 , 0 , 255 , 255) );
                            g_pD3DXFont_normal->DrawText(NULL , _T("CONGRATULATIONS") , -1 , &rect[CONGRATULATE_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 128 , 0 , 255) );
                            g_pD3DXFont_normal->DrawText(NULL , _T("PRESS ENTER or BUTTON") , -1 , &rect[ENDPRESS_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 0 , 255) );
                            
                            if(KEY(ENTER) || BUTTON_A){
                                StopMusic(BGM_ENDING);
                                music_flg = false;
                                state = TITLE;
                            }
                        }
                    }
                }
                break;
                
            //ftHg--------------------------------------------------------------------------------------------------------------------
            default:
                break;
        }
        // Direct3Dɂ`̏I
		g_pD3DDevice->EndScene();
	}
	// obNobt@ƃtgobt@̓ւ
	g_pD3DDevice->Present(NULL, NULL, NULL, NULL);
}
#if 0
/*
 #Region
//\n̊֐͈ȉ====================================================================================================
 #endif
*/
#endif

/*============================================================================
摜̕\(摜ԍ , 摜̖O , \ʒuX , 摜̑傫X , \ʒuY , 摜̑傫Y , 摜̑傫́Aʂ̑傫˂2ׂ̂̉XY)
//߂lFȂ
/*============================================================================*/
void print_img(short num , wchar_t *name , float place_x , float xdif , float place_y , float ydif , float bmp_ratio_x , float bmp_ratio_y){
    if(g_pTexture_array[num] == NULL){
        D3DXCreateTextureFromFileEx(g_pD3DDevice,			// foCXւ̃|C^
#if BORLAND
							      (const char*)name,	    // t@C̖O
#else
							      name,	                    // t@C̖O
#endif
        0,0,0,0,D3DFMT_UNKNOWN, D3DPOOL_DEFAULT,D3DX_FILTER_NONE, D3DX_DEFAULT,D3DCOLOR_ARGB(255,255,0,255), info,NULL,
							      &g_pTexture_array[num]);	// ǂݍރ[

    }
    // _W̐ݒ   //2ׂ̂Ɉ΂̂ŁAԂԂɂȂȂ悤ɂ邽߂ɂ͉摜̃TCY2ׂ̂ɍ킹
	g_vertexWk[0].vtx = D3DXVECTOR4(place_x     , place_y     , 0.0f, 1.0f);    //
	g_vertexWk[1].vtx = D3DXVECTOR4(place_x+xdif, place_y     , 0.0f, 1.0f);    //E
	g_vertexWk[2].vtx = D3DXVECTOR4(place_x     , place_y+ydif , 0.0f, 1.0f);   //
	g_vertexWk[3].vtx = D3DXVECTOR4(place_x+xdif, place_y+ydif , 0.0f, 1.0f);   //E

	// _J[E`l̐ݒ
	g_vertexWk[0].diffuse = D3DCOLOR_RGBA(255, 255, 255, 255);
	g_vertexWk[1].diffuse = D3DCOLOR_RGBA(255, 255, 255, 255);
	g_vertexWk[2].diffuse = D3DCOLOR_RGBA(255, 255, 255, 255);
	g_vertexWk[3].diffuse = D3DCOLOR_RGBA(255, 255, 255, 255);

	// eNX`W摜̕\͈͂̊)̐ݒ
	g_vertexWk[0].tex = D3DXVECTOR2(0.0f, 0.0f);                //2ׂ̂敪́A\Ƃ
	g_vertexWk[1].tex = D3DXVECTOR2(bmp_ratio_x, 0.0f);         // 640/1024
	g_vertexWk[2].tex = D3DXVECTOR2(0.0f, bmp_ratio_y);         //  24/  32 ƂA384/512 Ƃ
	g_vertexWk[3].tex = D3DXVECTOR2(bmp_ratio_x, bmp_ratio_y);  //摜̕(͍)ʂ̕(͍)̒l

    //\
	g_pD3DDevice->SetTexture(0, g_pTexture_array[num]);		
	g_pD3DDevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, g_vertexWk, sizeof(VERTEX_2D));
}

#if 0
/*
 #Region
//ȉ͎̏֐====================================================================================================
 #endif
*/
#endif

/*============================================================================
^Cg(Ȃ)
//߂lFȂ
/*============================================================================*/
void title(){
                
    //ߕ\
    word = (string)"PRESS ENTER or BUTTON";
#if !BORLAND
    MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, word.c_str(), -1, str2, 64);
    wsprintf(t_szbuf , _T("%s") , str2 );
#else
    wsprintf(t_szbuf , _T("%s") , word.c_str() );
#endif
    //g_pD3DXFont_title->DrawText(NULL , t_szbuf , -1 , &rect[1] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 0 , 255) );
                
    if(decide_flg != 1){
        //Press Enter
        if(cntFrame / 60 % 2 == 0){
            g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[2] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 0 , 255) );
        }
    }
    //Rs[Cg\
    g_pD3DXFont_normal->DrawText(NULL , _T("(c)GP12A-2010 `[A") , -1 , &rect[4] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 0 , 255) );
    
    if(hiscore < score){
        hiscore = score;
    }
    wsprintf(t_szbuf , _T("HISCORE:%d") , hiscore );
    g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[HISCORE_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 0 , 255) );
    



}

/*============================================================================
(Ȃ)
//߂lFȂ
/*============================================================================*/
void PlayStart(){
    //
    if( KEY(ENTER) || BUTTON_A ){

        decide_flg = 1;
        wait_time_cnt = 1;

        //炵
        StopMusic( BGM_TITLE );   //Xgbv~[WbN
        music_flg = false;
        PlayMusic( SE_DECIDE , false ); //ʉĐ

    }
    //{^
    else{
        //ɂȂ
    }

}

/*============================================================================
vC[̈ړ(Ȃ)
//߂lFȂ
/*============================================================================*/
void move(){

    //
    if(g_keyState[DIK_UP] & 0x80 || g_joyState[0].lY < (-MEMORY/2)){
        SetMoveSpeed();
        prev_ground_slide = 0;
        prev_ground_slide_LR = 0;
        //OĂȂ
        if(MOVABLE_BAR < jiki_y){
            jiki_y -= move_speed;
        }
    }
    //
    else if(g_keyState[DIK_DOWN] & 0x80 || g_joyState[0].lY > (MEMORY/2)){
        SetMoveSpeed();
        prev_ground_slide = 0;
        prev_ground_slide_LR = 0;
        //OĂȂ
        if(jiki_y < MOVABLE_UNDER){
            jiki_y += move_speed;
        }
    }
    //
    else{
        glide();
        glide_LR();
    }

    //
    if(g_keyState[DIK_LEFT] & 0x80 || g_joyState[0].lX < (-MEMORY/2)){
        SetMoveSpeed();
        prev_ground_slide = 0;        
        prev_ground_slide_LR = 0;
        //OĂȂ
        if(MOVABLE_LEFT < jiki_x){
            jiki_x -= move_speed;
        }
    }
    //
    else if(g_keyState[DIK_RIGHT] & 0x80 || g_joyState[0].lX > (MEMORY/2)){
        SetMoveSpeed();
        prev_ground_slide = 0;        
        prev_ground_slide_LR = 0;
        //EOĂȂ
        if(jiki_x < MOVABLE_RIGHT){
            jiki_x += move_speed;
        }
    }
    else{
        //Ȃ
    }    

    //}EX(}EX@ɏdȂNbNĂA@}EXɒǏ])
    if(jiki_y <= mouse_pos_y  && mouse_pos_y <= jiki_y + SELF_IMG_SIZE      //}EXWY@(c)͈͓̔
    && jiki_x <= mouse_pos_x  && mouse_pos_x <= jiki_x + SELF_IMG_SIZE){    //}EXWX@()͈͓̔
        //NbNĂ
        if(g_mouseState.rgbButtons[0] & 0x80){
            jiki_y = (float)(mouse_pos_y-(SELF_IMG_SIZE/2));
            jiki_x = (float)(mouse_pos_x-(SELF_IMG_SIZE/2));
        }
    }

    //^C
    if( KEY( ENTER) ){
        stop_time_flg = true;
    }


}

/*============================================================================
c̏(Ȃ)
//߂lFȂ
/*============================================================================*/
void glide(){
    //ʓ
    if(MOVABLE_BAR < jiki_y && jiki_y < MOVABLE_UNDER){
        //Xs[hcĂ
        if(move_speed < -1 || 1 < move_speed){
            //ĂB͏ĂȂ
            if( (!(g_keyState[DIK_UP] & 0x80) && g_keyStatePrev[DIK_UP] & 0x80 )                //L[{[hΉ
            || ( (g_joyState[0].lY > (-MEMORY/2)) && g_joyStatePrev[0].lY < (-MEMORY/2) ) ){    //pbhΉ
                //XCb`I
                //if(prev_ground_slide != 1)
                {
                    prev_ground_slide = 1;
                    //}CiXΒl
                    if(move_speed > 0 ){
                        move_speed *= -1;
                    }
                }
            }
            //ĂB͉ĂȂB
            else if( (!(g_keyState[DIK_DOWN] & 0x80) && g_keyStatePrev[DIK_DOWN] & 0x80)        //L[{[hΉ
                || ( (g_joyState[0].lY < (MEMORY/2)) && g_joyStatePrev[0].lY > (MEMORY/2) ) ){  //pbhΉ
                //XCb`I
                if(prev_ground_slide != 2){
                    prev_ground_slide = 2;
                }
            }
            
            //㊊\͌
            if(prev_ground_slide == 1){
                move_speed += 0.1f;
            }
            //\͌
            else if(prev_ground_slide == 2){
                move_speed -= 0.1f;
            }
            //蒆
            if(prev_ground_slide != 0){
                jiki_y += move_speed;   //
            }
        }
        //~܂(ƂA\͂A-0.9`+0.9ɂȂ)
        else{
            prev_ground_slide = 0;
            move_speed = 0;
        }
    }
}

/*============================================================================
̏(Ȃ)
//߂lFȂ
/*============================================================================*/
void glide_LR(){
    //ʓ
    if(MOVABLE_LEFT < jiki_x && jiki_x < MOVABLE_RIGHT){
        //Xs[hcĂ
        if(move_speed < -1 || 1 < move_speed){
            //ĂB͏ĂȂ
            if( (!(g_keyState[DIK_LEFT] & 0x80) && g_keyStatePrev[DIK_LEFT] & 0x80 )                //L[{[hΉ
            || ( (g_joyState[0].lX > (-MEMORY/2)) && g_joyStatePrev[0].lX < (-MEMORY/2) ) ){    //pbhΉ
                //XCb`I
                //if(prev_ground_slide != 1)
                {
                    prev_ground_slide_LR = 1;
                    //}CiXΒl
                    if(move_speed > 0 ){
                        move_speed *= -1;
                    }
                }
            }
            //ĂB͉ĂȂB
            else if( (!(g_keyState[DIK_RIGHT] & 0x80) && g_keyStatePrev[DIK_RIGHT] & 0x80)        //L[{[hΉ
                || ( (g_joyState[0].lX < (MEMORY/2)) && g_joyStatePrev[0].lX > (MEMORY/2) ) ){  //pbhΉ
                //XCb`I
                if(prev_ground_slide_LR != 2){
                    prev_ground_slide_LR = 2;
                }
            }
            
            //㊊\͌
            if(prev_ground_slide_LR == 1){
                move_speed += 0.1f;
            }
            //\͌
            else if(prev_ground_slide_LR == 2){
                move_speed -= 0.1f;
            }
            //蒆
            if(prev_ground_slide_LR != 0){
                jiki_x += move_speed;   //
            }
        }
        //~܂(ƂA\͂A-0.9`+0.9ɂȂ)
        else{
            prev_ground_slide_LR = 0;
            move_speed = 0;
        }
    }
}

/*============================================================================
蔻(Ȃ)
//߂lFȂ
/*============================================================================*/
void hantei(){
    if(stage_num == STAGE5_IMG){
        enemy[1] += enemy_speed;
        if(enemy[1] < SELF_IMG_SIZE){
            enemy_speed *= -1;
        }
        if(enemy[1] > SCREEN_WIDTH - SELF_IMG_SIZE){
            enemy_speed *= -1;
        }
    }
    for(int hantei_y = (int)jiki_y+5; hantei_y < (jiki_y+SELF_IMG_SIZE-5); hantei_y++){
        for(int hantei_x = (int)jiki_x+5; hantei_x < (jiki_x+SELF_IMG_SIZE-5); hantei_x++){
            if(stage_num != STAGE_EX){
                //S
                if(stage[stage_num-STAGE1_IMG][hantei_y/2][hantei_x/2] == 0){
                    state = DEATH;
                }
                //S[
                else if(stage[stage_num-STAGE1_IMG][hantei_y/2][hantei_x/2] == 2){
                    goal_flg = 1;
                }
                //Xe[WT͓G
                if(stage_num == STAGE5_IMG){
                    if(enemy[0] < hantei_y && hantei_y < enemy[0]+SELF_IMG_SIZE
                    && enemy[1] < hantei_x && hantei_x < enemy[1]+SELF_IMG_SIZE
                    ){
                        state = DEATH;
                    }
                }/**/
            }
            //Xe[WR͓
            else{
                if( *(map+((int)hantei_y/BLOCK_SIZE)*mapsize+( ( (int)hantei_x)/BLOCK_SIZE)-1 ) == 0){
                    state = DEATH;
                }
                else if(*(map+((int)hantei_y/BLOCK_SIZE)*mapsize+( ( (int)hantei_x) /BLOCK_SIZE)-1 ) == 2){   //}CiXŉE(vX)
                    goal_flg = 1;
                }
            }
        }
    }
    
    
    if(state == DEATH || goal_flg == 1){
        StopMusic( bgm_no );
        wait_time_cnt = 1;
        music_flg = false;
    }
}

/*============================================================================
~X̓(Ȃ)
//߂lFȂ
/*============================================================================*/
void death_move(){
    if(fall_flg == 0){
        death_move_speed += 0.5;
        if(death_move_speed >= 10){
            fall_flg = 1;
        }
        jiki_y -= death_move_speed;
    }
    else{
        if(death_move_speed >= -10){
            death_move_speed -= 0.5;
        }
        jiki_y -= death_move_speed;
    }
}

/*============================================================================
Xs[hݒ(Ȃ)
//߂lFȂ
/*============================================================================*/
void SetMoveSpeed(){

    move_speed = SPEED;     //ړx

    //_bV
    if(g_keyState[DIK_SPACE] & 0x80 || g_joyState[0].rgbButtons[1] & 0x80 ){
        move_speed /= 2;
    }

}

/*============================================================================
vCO(Ȃ)
//߂lFȂ
/*============================================================================*/
void stage_init(){
    
    //[h܂IĂȂ
    if(s_ini_flg != true){
        g_pD3DDevice->Clear(1, NULL, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(128, 
                                                                                        0, 
                                                                                        255, 0), 1.0f, 0);
        print_img(JIKI1 , str_moji[JIKI1] , 300.0f , SELF_IMG_SIZE , 200.0f ,  SELF_IMG_SIZE, 1.0f , 1.0f);

        wsprintf(t_szbuf , _T("x %d"),life);/**/
        g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[5] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );
        wsprintf(t_szbuf , _T("STAGE %d"),stage_num-STAGE1_IMG+1);/**/
        g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[6] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );
        g_pD3DXFont_normal->DrawText(NULL , _T("NOW LOADING...") , -1 , &rect[7] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );
        g_pD3DXFont_normal->DrawText(NULL , _T("PLEASE WAIT ABOUT 3 SEC!") , -1 , &rect[8] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );
        
        g_pD3DXFont_stgld->DrawText(NULL , _T("The movement speed is reduced by half")       , -1 , &rect[HELPHINT_POS1] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );
        g_pD3DXFont_stgld->DrawText(NULL , _T("  when doing while pushing the [SPACE KEY]!") , -1 , &rect[HELPHINT_POS2] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );
        
        g_pD3DXFont_stgld->DrawText(NULL , _T("  Use [MOUSE] , too!")                        , -1 , &rect[HELPHINT_POS2_1] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );
        g_pD3DXFont_stgld->DrawText(NULL , _T("  [CLICK] drag the character and move it!")   , -1 , &rect[HELPHINT_POS2_2] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );

        wait_time_cnt = 1;
        s_ini_flg = true;   //[h܂

        death_state = 0;
        fall_flg = 0;
        death_move_speed = 0;
        goal_flg = 0;
        prev_ground_slide = 0;         //O͂̎cňړ
        prev_ground_slide_LR = 0;      //O͂̎c(E)
        
        if(stage_num == STAGE6_IMG){
            time_limit_val = 150;
        }
        else{
            time_limit_val = 100;
        }
    }

}

/*============================================================================
~X(Ȃ)
//߂lFȂ
/*============================================================================*/
void death2_screen(){
    g_pD3DDevice->Clear(1, NULL, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(128, 
                                                                                    0, 
                                                                                    255, 0), 1.0f, 0);
    print_img(JIKI_DEATH , str_moji[JIKI_DEATH] , 384.0f , SELF_IMG_SIZE , 240.0f ,  SELF_IMG_SIZE, 1.0f , 1.0f);

    g_pD3DXFont_normal->DrawText(NULL , _T("YOU DIED!") , -1 , &rect[10] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );
    g_pD3DXFont_stgld->DrawText(NULL , _T("PRESS ENTER") , -1 , &rect[DIED_ENTER_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 255 , 255 , 255) );


}

/*============================================================================
~X(Ȃ)
//߂lFȂ
/*============================================================================*/
void dying(){
    if(death_state != 2){
        if(KEY(ENTER) || BUTTON_A){
            wait_time_cnt = 1;
            StopMusic( BGM_LOSE );   //Xgbv~[WbN
            music_flg = false;
            death_state = 2;
        }
    }
}

/*============================================================================
fobO\p(Ȃ)
//߂lFȂ
/*============================================================================*/
void debug_print(){
    
    wsprintf(t_szbuf , _T("%d"),(int)jiki_x);/**/
    g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[3] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 128 , 255) );
    //fobOp
/*  wsprintf(t_szbuf , _T("%d %d %d %d\n%d %d %d %d "),global_test_xx ,bug_aa , bug_c , bug_j , bug_i , bug_test  , randx() , xx);/**/
/*  g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[3] , DT_LEFT , D3DCOLOR_RGBA(255 , 0 , 128 , 255) );/**/
    
}

/*============================================================================
L̃Aj(Ȃ)
//߂lFȂ
/*============================================================================*/
void chara_anime(){
    static int anime_flg = 0;
    
    if(cntFrame % BLINK_FRAME == 0
    && stop_time_flg == true){
        cntFrame++;
    }
    
    switch(anime_flg){
        case 0:
            print_img(JIKI1 , str_moji[JIKI1] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 1;
            }
            break;

        case 1:
            print_img(JIKI2 , str_moji[JIKI2] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
            if(cntFrame % (BLINK_FRAME) == 0){
                anime_flg = 2;
            }
            break;

        case 2:
            print_img(JIKI3 , str_moji[JIKI3] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 3;
            }
            break;

        case 3:
            print_img(JIKI4 , str_moji[JIKI4] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 4;
            }
            break;

        case 4:
            print_img(JIKI5 , str_moji[JIKI5] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 5;
            }
            break;

        case 5:
            print_img(JIKI4 , str_moji[JIKI4] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 6;
            }
            break;

        case 6:
            print_img(JIKI3 , str_moji[JIKI3] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 7;
            }
            break;

        case 7:
            print_img(JIKI2 , str_moji[JIKI2] , jiki_x , SELF_IMG_SIZE , jiki_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 0;
            }
            break;

        default:
            break;
    }
    
}

/*============================================================================
(Ȃ)
//߂lFȂ
/*============================================================================*/
void time_limit(){
    if(time_limit_val > 0
    && goal_flg != 1
    && state != DEATH){
        if(cntFrame % 60 == 0){
            time_limit_val--;
        }
    }
    else{
        if(state == STAGE
        && goal_flg != 1){
            state = DEATH;
            StopMusic( bgm_no );
            music_flg = false;
            wait_time_cnt = 1;
        }
    }
    print_img(JIKI0 , str_moji[JIKI0] , 0 , SELF_IMG_SIZE , 0 ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //L
    wsprintf(t_szbuf , _T("~%d@@@@@@@rbnqdF%03d@@@@@@@shldF%03d") , life , score , time_limit_val);/**/
    g_pD3DXFont_normal->DrawText(NULL , t_szbuf , -1 , &rect[TIMELIMIT_POS] , DT_LEFT , D3DCOLOR_RGBA(0 , 255 , 0 , 255) );
    
    if(stop_time_flg == true){
        g_pD3DXFont_normal->DrawText(NULL , _T("PAUSE") , -1 , &rect[STOP_TIME_POS] , DT_LEFT , D3DCOLOR_RGBA(255 , 200 , 0 , 255) );
    }
    
}

/*============================================================================
Xe[W`bṽubN\(Ȃ)
//߂lFȂ
/*============================================================================*/
void LoadAndDrowDot(){
    int maptip;
    
    //1񂱂p
    if(write_screen_flg == 0){
        
        /* obNobt@yobt@̃NA
	    g_pD3DDevice->Clear(0, NULL, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(0, 
                                                                                         0, 
                                                                                         255, 0), 1.0f, 0);/**/
        //ʏcS
        for(int stage_y_dot_num = 0; stage_y_dot_num < mapsize ; stage_y_dot_num++){
            hanni.y1 = (BLOCK_SIZE*0) + (BLOCK_SIZE) * stage_y_dot_num  + scroll_y;
            hanni.y2 = hanni.y1 + (BLOCK_SIZE);
            
            //ʉS
            for(int stage_x_dot_num = 0; stage_x_dot_num < mapsize ; stage_x_dot_num++){
                hanni.x1 = (BLOCK_SIZE) + (BLOCK_SIZE) * stage_x_dot_num;
                hanni.x2 = hanni.x2 + (BLOCK_SIZE);
                maptip = *(map + stage_y_dot_num * mapsize + stage_x_dot_num);  //}bṽf[^Rs[
                
                //()
                if(mapDat[maptip] == 0){
                    g_pD3DDevice->Clear(1, &hanni, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(0, 
                                                                                        0, 
                                                                                        0, 0), 1.0f, 0);
                }
                //Ȃ()
                else if(mapDat[maptip] == 255){
                    g_pD3DDevice->Clear(1, &hanni, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(255, 
                                                                                    255, 
                                                                                    255, 0), 1.0f, 0);
                }
                //S[()
                else if(mapDat[maptip] == 2){
                    g_pD3DDevice->Clear(1, &hanni, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(255, 
                                                                                    0, 
                                                                                    0, 0), 1.0f, 0);
                }
                
            }
        }

        print_wall();   //㉺Ǖ\
        //OhԂ
        hanni.y1 = -BLOCK_SIZE + scroll_y;
        hanni.y2 = SCREEN_HEIGHT + scroll_y;
        hanni.x1 = (BLOCK_SIZE) + (BLOCK_SIZE) * ( (SCREEN_HEIGHT/BLOCK_SIZE)-1 ) +(BLOCK_SIZE) ;
        hanni.x2 = hanni.x2 + (BLOCK_SIZE)*( (SCREEN_WIDTH-hanni.x2) / BLOCK_SIZE );
        g_pD3DDevice->Clear(1, &hanni, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(0, 
                                                                        0, 
                                                                        255, 0), 1.0f, 0);
    }
}


/*============================================================================
Ǖ\(Ȃ)
//߂lFȂ
/*============================================================================*/
void print_wall(){
    
    //Oǁij
    hanni.y1 = -BLOCK_SIZE +scroll_y;
    hanni.y2 = hanni.y1 + BLOCK_SIZE ;
    hanni.x1 = 0 ;
    hanni.x2 = (BLOCK_SIZE) * (mapsize + 2);
    g_pD3DDevice->Clear(1, &hanni, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(0, 
                                                                        0, 
                                                                        0, 0), 1.0f, 0);
    //Oǁij
    hanni.y1 = (BLOCK_SIZE)*mapsize +scroll_y;
    hanni.y2 = hanni.y1           +  BLOCK_SIZE;
    hanni.x1 = 0 ;
    hanni.x2 = (BLOCK_SIZE) * (mapsize + 2);
    g_pD3DDevice->Clear(1, &hanni, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(0, 
                                                                        0, 
                                                                        0, 0), 1.0f, 0);
    //Oǁij
    hanni.y1 = -BLOCK_SIZE +scroll_y;
    hanni.y2 = hanni.y1 + (BLOCK_SIZE) * (mapsize + 2);
    hanni.x1 = 0;
    hanni.x2 = hanni.x1 + BLOCK_SIZE;
    g_pD3DDevice->Clear(1, &hanni, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(0, 
                                                                        0, 
                                                                        0, 0), 1.0f, 0);
    //OǁiEj
    hanni.y1 = -BLOCK_SIZE +scroll_y;
    hanni.y2 = hanni.y1 + (BLOCK_SIZE) * (mapsize + 2);
    hanni.x1 = (BLOCK_SIZE)+ (BLOCK_SIZE)*mapsize;
    hanni.x2 = hanni.x1 + BLOCK_SIZE;
    g_pD3DDevice->Clear(1, &hanni, (D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER), D3DCOLOR_RGBA(0, 
                                                                        0, 
                                                                        0, 0), 1.0f, 0);
    return;
}

/*============================================================================
}bv̎쐬(XYoɏ㉺E̕li[\)
//߂lFȂ
/*============================================================================*/
void mapCreate(POS subpos){
    
	int mv;						//ړipj
	int movchk[4] = {0,0,0,0};	//4`FbN
	POS mpos;
	int mx,my;					//̓`FbNp
	bool loopflag = true;		//[vtO
	int i;
	
	//@ݒ
    *(map + MapPos.y * mapsize + MapPos.x) = 1;	//
	
	//S[ʒu̐ݒ
	SubCount++;					//[xJE^Abv
	if(MaxCount < SubCount){
		MaxCount = SubCount;	//[xXV
		GoalPos = subpos;		//S[ʒuޔ
	}
	
	
	while(loopflag){
#if MOTION		
		mv = randx() % 4;	//
#else
		mv = rand() % 4;	//
#endif
		//ړς݃`FbN
		if(movchk[ mv ] == 0){
			
			movchk[ mv ] = 1;	//ړς݃tOON
			
			//ړ`FbN
			if( (mv == 1 || mv == 3)
			&&( subpos.x % 2) != 0 ){
				continue;
			}
			if( (mv == 0 || mv == 2)
			&&( subpos.y % 2) != 0 ){
				continue;
			}
			//ړ
			mpos.x = subpos.x + r_move[ mv ].x;
			mpos.y = subpos.y + r_move[ mv ].y;
			
			//Oǃ`FbN
			if(mpos.x < 0 || mpos.x > mapsize-1 || mpos.y < 0 || mpos.y > mapsize-1){
				continue;
			}
			//t`FbN(Ɍ@ς)
			if( *(map + mpos.y * mapsize + mpos.x) == 1){	//H
				continue;
			}
			for(i = 0; i < 4; i++){
				mx = mpos.x + r_move[ i ].x;
				my = mpos.y + r_move[ i ].y;
				
				if(mx < 0 || mx > mapsize-1 || my < 0 || my > mapsize-1 ){
					continue;	//Oǂ͖Ȃ
				}
				if(mx == subpos.x && my == subpos.y){
					continue;	//ʒu͖Ȃ
				}
				if(*(map+my*mapsize+mx)==1){
					break;	//ǂʒuNG
				}
			}
			if(i == 4){
				//ړW
				MapPos = mpos;
				//ċAĂяoŃ}bv쐻
				mapCreate(MapPos);
			}
		}
		loopflag = false;
		for(i = 0; i < 4; i++){
			if(movchk[i] == 0){	//ĂȂ
				loopflag = true;
				break;
			}
		}
	}
	//[xJE^̕ύXi󂭁j
	SubCount--;
    return ;
}
