//==============================================
// TEh [sound.cpp]
//==============================================

#include "../head/sound.h"

//******************************
// \́E}N`
//******************************/

// ȃp[^\
typedef struct
{
	TCHAR *filename;
	bool bLoop;
} PARAM;

#define MAX_SOUND		(sizeof(g_param) / sizeof(PARAM))		// Ȑ


//******************************
// O[oϐ
//******************************/
// ȃf[^ꎮ
PARAM g_param[] =
{
	{_T("BGM/title_ma-jan.mid"), true},		// 0.^CgBGM
	{_T("BGM/stage1_fz2.mid"), true},		// 1.Q[BGM1
	{_T("BGM/stage2_hebe_pass.mid"), true},	// 2.Q[BGM2
	{_T("BGM/stage3_fz4.mid"), true},		// 3.Q[BGM3
	{_T("BGM/stage4_ya-da-yo.mid"), true},	// 4.Q[BGMEX
	{_T("BGM/stage5_ff6.mid"), true},		// 5.Q[BGM5
	{_T("BGM/stage6_vsbd2.mid"), true},		// 6.Q[BGM6(Xg)
	{_T("BGM/mario4_goal.mid"), false},	    // 7.y
	{_T("BGM/bk_go.mid"), false},		    // 8.Sy
	{_T("BGM/clear.mid"), false},		    // 9.GfBOy
	{_T("SE/Sound_Decide.wav"), false},	    //10.艹
	{_T("SE/p.wav"), false},	            //11.S
	{_T("SE/EX.wav"), false},	            //12.GhnCXRA\
};

IDirectMusicLoader8*		g_pLoader = NULL;					// [_[
IDirectMusicPerformance8*	g_pPerformance = NULL;				// ptH[}X
IDirectMusicSegment8*		g_pSegment[MAX_SOUND]/* = {}*/;			// ZOg
IDirectMusicAudioPath8*		g_pAudioPath = NULL;				// I[fBIpX
long						g_lVolume;							// {[l

LPDIRECTSOUNDBUFFER8		g_pDSBuffer = NULL;



//==============================
// 
//==============================
HRESULT InitSound(HWND hWnd)
{
	HRESULT hr;

	// bnl̏
	hr = CoInitialize(NULL);
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("COM̏Ɏs܂B"), _T("x"), MB_OK);
		return hr;
	}

	// ptH[}X̍쐬
	hr = CoCreateInstance(CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC,
								IID_IDirectMusicPerformance8, (void**)&g_pPerformance);
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("ptH[}X̍쐬Ɏs܂B"), _T("x"), MB_OK);
		return hr;
	}

	// ptH[}X̏
	hr = g_pPerformance->InitAudio(NULL, NULL, NULL,
									DMUS_APATH_DYNAMIC_STEREO, 64, DMUS_AUDIOF_ALL, NULL);
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("ptH[}X̏Ɏs܂B"), _T("x"), MB_OK);
		return hr;
	}

	// [_[̍쐬
	hr = CoCreateInstance(CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC,
								IID_IDirectMusicLoader8, (void**)&g_pLoader);
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("[_̍쐬Ɏs܂B"), _T("x"), MB_OK);
		return hr;
	}

	// JgfBNg擾
	WCHAR wstrSearchPath[MAX_PATH];

	CHAR strPath[MAX_PATH];
	GetCurrentDirectoryA(MAX_PATH, strPath);
	MultiByteToWideChar(CP_ACP, 0, strPath, -1, wstrSearchPath, MAX_PATH);		// Unicode ɕϊ

	// fBNgݒ
	hr = g_pLoader->SetSearchDirectory(GUID_DirectMusicAllTypes, wstrSearchPath, false);
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("fBNg̐ݒɎs܂B"), _T("x"), MB_OK);
		return hr;
	}

	for(int cnt = 0; cnt < MAX_SOUND; cnt++)
	{
        WCHAR lpWideCharStr[256]; MultiByteToWideChar(CP_ACP , 0 , (LPCSTR)g_param[cnt].filename , -1 , lpWideCharStr , 256 );
		// t@CZOg[h  NXʎq               ړĨC^[tFCXhc    t@C      C^[tFCX󂯎|C^
		hr = g_pLoader->LoadObjectFromFile(CLSID_DirectMusicSegment ,       //NXʎq
                                            IID_IDirectMusicSegment8  ,     //ړĨC^[tFCXhc
#if VS_COMPILE
                                            (WCHAR*)g_param[cnt].filename , //t@C
#else
                                            lpWideCharStr ,
#endif
                                            (LPVOID *)&g_pSegment[cnt]);	//C^[tFCX󂯎|C^
		if(FAILED(hr))
		{
            TCHAR print_str[128];
            wsprintf(print_str , _T("ZOg̃[hɎs܂B\n%s , %d\nhr=%d,CLSID=%d,IID=%d,segment=%p,%d"),
                     g_param[cnt].filename  ,   cnt ,   hr  ,   CLSID_DirectMusicSegment    ,   IID_IDirectMusicSegment8    ,
                     &g_pSegment[cnt]   ,   &g_pSegment[cnt]);/**/
                     
			MessageBox(hWnd, print_str , _T("x"), MB_OK);
			return hr;
		}

		// oh̃_E[h
		g_pSegment[cnt]->Download(g_pPerformance);
	}

	// I[fBIpX̍쐬
	hr = g_pPerformance->CreateStandardAudioPath(DMUS_APATH_DYNAMIC_STEREO, 64, true, &g_pAudioPath);
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("I[fBIpX̍쐬Ɏs܂B"), _T("x"), MB_OK);
		return hr;
	}

	// [v̐ݒ
	for(int cnt = 0; cnt < MAX_SOUND; cnt++)
	{
		if(g_param[cnt].bLoop)
		{
			// [v|Cg̐ݒ
			hr = g_pSegment[cnt]->SetLoopPoints(0, 0);
			if(FAILED(hr))
			{
				MessageBox(hWnd, _T("[v|Cg̐ݒɎs܂B"), _T("x"), MB_OK);
				return hr;
			}

			// [ṽs[g񐔂̐ݒ
			hr = g_pSegment[cnt]->SetRepeats(DMUS_SEG_REPEAT_INFINITE);
			if(FAILED(hr))
			{
				MessageBox(hWnd, _T("[ṽs[g񐔂̐ݒɎs܂B"), _T("x"), MB_OK);
				return hr;
			}
		}
	}

	// {[̐ݒ
	g_lVolume = 0;								// "0"͍ő{[
	g_pAudioPath->SetVolume(g_lVolume, 0);

	return S_OK;
}

//==============================
// 
//==============================
void UninitSound(void)
{
	if(g_pPerformance)
	{
		// ~
		g_pPerformance->Stop(NULL, NULL, 0, 0);

		// ptH[}X
		g_pPerformance->CloseDown();
	}

	// C^[tFCX̉
	SAFE_RELEASE(g_pDSBuffer);
	SAFE_RELEASE(g_pAudioPath);
	SAFE_RELEASE(g_pLoader);
	SAFE_RELEASE(g_pPerformance);

	// ȃf[^̉
	for(int cnt = 0; cnt < MAX_SOUND; cnt++)
		SAFE_RELEASE(g_pSegment[cnt]);

	// bnl
	CoUninitialize();
}

//==============================
// ZOgĐ
//==============================
HRESULT PlayMusic(int songno, DWORD flags)
{
	HRESULT	hr;

	// ԍ`FbN
	if(songno < 0 || songno >= MAX_SOUND)
	{
		return S_FALSE;
	}

	// ZOg̍ĐJn
	hr = g_pPerformance->PlaySegmentEx(g_pSegment[songno], NULL, NULL,
										flags, 0, NULL, NULL, g_pAudioPath);
	
	return hr;
}


//==============================
// Đ~
//==============================
HRESULT StopMusic(int songno)
{
	HRESULT	hr;

	// ԍ`FbN
	if(songno < 0 || songno >= MAX_SOUND)
		return S_FALSE;

	// ~R}h
	hr = g_pPerformance->StopEx(g_pSegment[songno], 0, 0);
	
	return hr;
}
