//==============================================
// Q[̃C [game.h]
//==============================================
#ifndef _GAME_H_
#define _GAME_H_

/*========================================================================*/
/*XV\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*b10/01/19    ver0.1 UP(x[X̍쐬)                                 b*/
/*b10/01/20    \\                                              b*/
/*b10/01/21    ͏ǉ(ړA|[YA̋ʐFRs[)            b*/
/*b10/01/22    ʐF炵ǉ                                          b*/
/*b10/01/24    ʂ̐ݒu                                            b*/
/*b10/01/25    Q[I[o[Aݒuړǉ                      b*/
/*b10/01/26    ʂ̏ǉ                                            b*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*========================================================================*/

/*==============================*/
/* CN[h                 */
/*==============================*/
#include "main.h"
#include "input.h"
#include "sound.h"
#include "graphics.h"
#include "CpAllObjFunc.h"

//==============================
// 萔
//==============================
enum{   //ʏԑJڗp-----------
    TITLE = 0,
    PUYO_EX,

    ENUM_END
};

enum{   //摜ԍ-----------
    BACK,
    BALL,

    END_NUM_IMG
};

enum{   //`ʒu-----------
    TITLE_POS  ,
    ANNOTATION , //
    SUB_TITLE  ,
    SCORE_STR_POS  ,
    LV_STR_POS ,
    JEWEL_STR_POS ,
    SCORE_POS  ,
    LV_POS ,
    JEWEL_POS ,
    CNTDOWN_POS ,
    CNTDOWN_GO_POS ,
    NEXT_POS,
    PAUSE_POS,
    DEBUG_POS,
    GAMEOVER_POS,
    PUSH_ENTER_POS,
    ERASENUM_MESPOS,

    RECT_NUM
};

#define SELF_IMG_SIZE       32      //@摜TCY
#define NEXT_BALL_POS_X    520      //ʈʒuX
#define NEXT_BALL_POS_Y    310      //ʈʒuY

#define APPEARANCE_POS_X   288      //oʒuX
#define APPEARANCE_POS_Y    18      //oʒuY

//ړ\͈Y
#define MOVABLE_BAR     18
#define MOVABLE_UNDER   (480-18-(32*3))
//ړ\͈X
#define MOVABLE_LEFT    224
#define MOVABLE_RIGHT   362
//^CgJ[
#define TITLE_BACK_COLOR_RED_VALUE     60
#define TITLE_BACK_COLOR_GREEN_VALUE   24
#define TITLE_BACK_COLOR_BLUE_VALUE   126
//tHgTCY
#define FS_TTL 108
#define FS_NUM  72
#define FS_STR  36
#define FS_PLY  18

#define SPEED    5 //vC[̒ʏXs[h
#define MEMORY 256 //i[̈

#define ENTER   DIK_RETURN  //G^[

//==============================
// }N֐(p)
//==============================
#define KEY(_x_)            ( (g_keyState[_x_] & 0x80) && !(g_keyStatePrev[_x_] & 0x80) )    //L[ϖh~

//vC[pbh{^ϖh~
#define BUTTON(_p_ , _a_ )  ( (g_joyState[_p_].rgbButtons[_a_] & 0x80) && !(g_joyStatePrev[_p_].rgbButtons[_a_] & 0x80) )

#define UP      ( ( MOVABLE_BAR  < jiki_y ) && (g_keyState[DIK_UP]    & 0x80 || g_joyState[0].lY < (-MEMORY/2) ) )	//
#define DOWN    ( ( jiki_y < MOVABLE_UNDER) && (g_keyState[DIK_DOWN]  & 0x80 || g_joyState[0].lY > ( MEMORY/2) ) )	//
#define LEFT    ( ( MOVABLE_LEFT < jiki_x ) && (g_keyState[DIK_LEFT]  & 0x80 || g_joyState[0].lX < (-MEMORY/2) ) )	//
#define RIGHT   ( ( jiki_x < MOVABLE_RIGHT) && (g_keyState[DIK_RIGHT] & 0x80 || g_joyState[0].lX > ( MEMORY/2) ) )	//

//******************************
// \́ENX
//******************************/
typedef struct{
    float u;
    float v;
}color_info;    //ݒu̐FA}bvɃRs[邽߂̂

//******************************
// vg^CvEextern錾
//******************************/
void InitGame(HWND hWnd);		//
void UninitGame(void);			//I
void Update(void);				//XV
void Draw(void);				//`揈

void print_img(short , wchar_t* , float , float , float , float , float , float , float , float);   //摜\
void title();           		    //^Cg\
void print_base_back(); 		    //{wi\

void before_begin();    		    //JnO
void slct_color();      		    //Fݒ
void move();                	    //ړ

void pause();               	    //Xgbv
void color_move();          	    //F]
void ball_ground_set();             //ʒnʐݒu

void erase_3same_color();           //3AF̏
void row_erase( int , int );        //c
void col_erase( int , int );        //
void rightdown_erase( int , int );  //E΂߉
void rightup_erase( int , int );    //E΂ߏ

void game_over();                   //Q[I[o[
void stuff_blank();                 //󔒋l

#endif
