//==============================================
// C [main.cpp]
//==============================================
#include "../head/main.h"
#include "../head/graphics.h"
#include "../head/input.h"
#include "../head/sound.h"
#include "../head/game.h"

//******************************
// }N`
//******************************/
#define CLASS_NAME			_T("AppClass")					// EChẼNX
#define WINDOW_NAME			_T("RkEX")			// EChẼLvV


//******************************
// vg^Cv錾
//******************************/
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);	// vV[W

//******************************
// O[oϐ
//******************************/
int g_XPos = 0;			// }EXXW
int g_YPos = 0;			// }EXYW

//==============================
// C֐
//==============================
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);	// ĂǂǁAxoigp錾j
	UNREFERENCED_PARAMETER(lpCmdLine);		// ĂǂǁAxoigp錾j

	WNDCLASSEX	wcex = {
		sizeof(WNDCLASSEX),
		CS_CLASSDC,
		WndProc,
		0,
		0,
		hInstance,
		NULL,
		LoadCursor(NULL, IDC_ARROW),
		(HBRUSH)(COLOR_WINDOW+1),
		NULL,
		CLASS_NAME,
		NULL
	};

	HWND		hWnd;
	MSG			msg;
	
	// EBhENX̓o^
	RegisterClassEx(&wcex);

	// EBhE̍쐬
	hWnd = CreateWindow(CLASS_NAME,
						WINDOW_NAME,
						WS_OVERLAPPEDWINDOW ^ WS_THICKFRAME,    //EBhECӊgkłȂ悤ɂ
						CW_USEDEFAULT,																		// EBhE̍W
						CW_USEDEFAULT,																		// EBhȄW
						SCREEN_WIDTH + GetSystemMetrics(SM_CXDLGFRAME)*2,									// EBhE
						SCREEN_HEIGHT + GetSystemMetrics(SM_CXDLGFRAME)*2+GetSystemMetrics(SM_CYCAPTION),	// EBhEc
						NULL,
						NULL,
						hInstance,
						NULL);


	// DirectX̏(EBhE쐬Ăs)
	if(FAILED(InitGraphics(hWnd, true)))
	{
		return -1;
	}

	// DirectInput
	InitInput(hInstance, hWnd);

	// TEh̏
	InitSound(hWnd);

	// Q[
	InitGame(hWnd);

		
	// t[JEg
	// KvȕϐpӁB
	DWORD dwExecLastTime;		// ŌɃQ[[vs
	DWORD dwCurrentTime;		// ݎ
	
	timeBeginPeriod(1);					// \ݒ(ǂꂾׂԂv邩~bŎw)
	dwExecLastTime = timeGetTime();		// VXe~bPʂŎ擾
	//dwCurrentTime = 0;					// ݎ͂Ƃ肠[

	// EChE̕\(Init()̌ɌĂ΂ȂƑʖ)
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	
	// bZ[W[v
	while(1)
	{
        if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if(msg.message == WM_QUIT)
			{// PostQuitMessage()Ă΂ꂽ烋[vI
				break;
			}
			else
			{
				// bZ[W̖|ƃfBXpb`
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
        }
		else
		{
			dwCurrentTime = timeGetTime();		// ݂̃VXe擾
			
			if((dwCurrentTime - dwExecLastTime) >= (1000 / 60))		// ÕQ[1/60bo߂
			{
				dwExecLastTime = dwCurrentTime;		// ۑ
				
				// XV
				Update();

				// `揈
				Draw();
			}
		}
	}

	// Q[I
	UninitGame();
	
	// EBhENX̓o^
	UnregisterClass(CLASS_NAME, wcex.hInstance);

	// OtBbNXI
	UninitGraphics();

	// DirectInputI
	UninitInput();

	// TEh̏I
	UninitSound();

	return (int)msg.wParam;
}

//==============================
// vV[W
//==============================
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch( message )
	{
	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_KEYDOWN:
		switch(wParam)
		{
		case VK_ESCAPE:					// [ESC]L[ꂽ
			DestroyWindow(hWnd);		// EBhEj悤w
			break;
		}
		break;
    case WM_MOUSEMOVE:
        g_XPos = LOWORD(lParam);
        g_YPos = HIWORD(lParam);
        break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}

	return 0;
}

