//-----------------------------------------------------------------------
// <copyright file="QuestionManager.cs">
// </copyright>
//-----------------------------------------------------------------------

#define ONEONE // ϐ錾ĕۑ

using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Xml;
using System.Xml.Schema;

namespace DataManagement
{
    /// <summary>
    /// f[^̓ǂݍ݂ o^s܂B
    /// </summary>
    public class QuestionManager
    {
        #region tB[h
        /// <summary>
        /// ͂Ȃǂ̃f[^(╪̑SẴ^f[^)i[܂B
        /// </summary>
        private List<QuestionBase> lstQuestionData;
        
        /// <summary>
        /// XMLt@C̓ǂݍ/ۑɎgp܂B
        /// </summary>
        private XmlDocument doc;

        /// <summary>
        /// t@CpX
        /// </summary>
        private string file_path;
        #endregion

        #region RXgN^
       
        /// <summary>
        /// RXgN^(XMLǂݍݏ{܂B)
        /// </summary>
        /// <param name="file_path">XMLt@CpX</param>
        public QuestionManager(string file_path)
        {
            // 錾
            XmlNodeList xnl;             // XMLm[hXg
            Question1Select4Answer temp; // IuWFNg̈ꎞۊǗp

            // i[̗p
            this.lstQuestionData = new List<QuestionBase>();
            this.file_path = file_path;

            try
            {
                // t@C̗LmF
                if (File.Exists(file_path))
                {
                    // XMLt@C̓ǂݍ
                    this.doc = this.LoadXmlDocument();

                    // ǂݍފKww
                    xnl = this.doc.SelectNodes(QuestionFixNum.QUESTION_LAYER);

                    // XMLt@C擾
                    foreach (XmlNode xn in xnl)
                    {
                        // IuWFNg̈ꎞۊǗp
                        temp = new Question1Select4Answer();

                        // ̒l擾(`AoNAA敪Aԍ)
                        temp.QuestionForm = 0;
                        temp.Year = int.Parse(xn.ParentNode.Attributes.GetNamedItem(QuestionFixNum.NODE_YEAR).Value);
                        temp.Season = xn.ParentNode.Attributes.GetNamedItem(QuestionFixNum.NODE_SEASON).Value;
                        temp.TimeDiv = xn.ParentNode.Attributes.GetNamedItem(QuestionFixNum.NODE_TIME).Value;
                        temp.QuestionNo = int.Parse(xn.Attributes.GetNamedItem(QuestionFixNum.NODE_NO).Value);

                        // qm[h̗vf擾(́AIx4AA)
                        temp.Sentence = xn.ChildNodes.Item(0).InnerText;
                        temp.Choices[0] = xn.ChildNodes.Item(1).InnerText;
                        temp.Choices[1] = xn.ChildNodes.Item(2).InnerText;
                        temp.Choices[2] = xn.ChildNodes.Item(3).InnerText;
                        temp.Choices[3] = xn.ChildNodes.Item(4).InnerText;
                        temp.Answer = int.Parse(xn.ChildNodes.Item(5).InnerText);
                        temp.Category = xn.ChildNodes.Item(6).InnerText;

                        // IuWFNg̒ǉ
                        this.lstQuestionData.Add(temp);
                    }
                }
            }
            catch (Exception ex)
            {
                // t@C̃bNAꕔm[h@̏ꍇ
                throw ex;
            }
        }
        #endregion

        #region public\bh
        /// <summary>
        /// Sēǂݍ񂾖f[^Ăяo(ʑ)ɕԂ܂B
        /// </summary>
        /// <returns>List^@S╪̃f[^Ԃ܂B</returns>
        public List<QuestionBase> GetQuestionData()
        {
            return this.lstQuestionData;
        }

        /// <summary>
        /// w萔ǂݍ񂾖f[^Ăяo(ʑ)ɕԂ܂B
        /// </summary>
        /// <param name="num">󂯎肽̐n܂B(F10)</param>
        /// <returns>List^@w肵̖₢̃f[^Ԃ܂B</returns>
        public List<QuestionBase> GetQuestionData(int num)
        {
            // 蕪_擾̂߂̗p
            List<QuestionBase> qblist = new List<QuestionBase>();   // 10╪̖擾邽߂̗̈
            int[] array = new int[num];                             // _ŉԖڂ̖擾ۊǗp

            try
            {
                if (num <= this.lstQuestionData.Count)
                {
                    for (int now = 0; now < num; now++)
                    {
                        // 擾`FbNĂяo
                        this.CheckSameNum(array, now, num);

                        // ̃_擾
                        qblist.Add(this.lstQuestionData[array[now]]);
                    }
                }
                else
                {
                    throw new Exception(
                        string.Format(
                        "o^ȏ̖擾悤Ƃ܂B\n̂ {0}łB",
                        this.lstQuestionData.Count));
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return qblist;
        }

        /// <summary>
        /// QuestionBaseIuWFNg󂯎 XMLt@Cœo^郁\bhłB
        /// </summary>
        public void SaveQuestionData()
        {
            // ^O
#if ONEONE
            XmlElement layer_ex;
            XmlElement examinationEle;
            XmlElement questionEle;
            XmlElement sentenceEle;
            XmlElement[] choiceEle;
            XmlElement answerEle;
            XmlElement categoryEle;

            // g񂵗p
            XmlElement layer_exTemp;
            XmlElement examinationEleTemp;
            XmlElement questionEleTemp;
            XmlElement sentenceEleTemp;
            XmlElement[] choiceEleTemp;
            XmlElement answerEleTemp;
            XmlElement categoryEleTemp;
            XmlTextWriter tw = null;
#else
            // ^O̐ݒ菀
            XmlElement[] tag = new XmlElement[(int)QuestionFixNum.TAG_NAME.TAG_NAME_NUM];
            XmlElement[] tagClone = new XmlElement[(int)QuestionFixNum.TAG_NAME.TAG_NAME_NUM];
#endif            
            try
            {
                // XML^O̐ݒ([gAAÁAIx4AA)
                this.doc = new XmlDocument();
#if ONEONE
                layer_ex = this.doc.CreateElement(QuestionFixNum.EXAMINATIONS_LAYER);
                examinationEle = this.doc.CreateElement(QuestionFixNum.NODE_EXAMINATION);
                questionEle = this.doc.CreateElement(QuestionFixNum.NODE_QUESTION);
                sentenceEle = this.doc.CreateElement(QuestionFixNum.NODE_SENTENCE);
                choiceEle = new XmlElement[4];
                choiceEle[0] = this.doc.CreateElement(QuestionFixNum.NODE_CHOICE);
                choiceEle[1] = this.doc.CreateElement(QuestionFixNum.NODE_CHOICE);
                choiceEle[2] = this.doc.CreateElement(QuestionFixNum.NODE_CHOICE);
                choiceEle[3] = this.doc.CreateElement(QuestionFixNum.NODE_CHOICE);
                answerEle = this.doc.CreateElement(QuestionFixNum.NODE_ANSWER);
                categoryEle = this.doc.CreateElement(QuestionFixNum.NODE_CATE);
#else
                foreach (QuestionFixNum.TAG_NAME tag_name in Enum.GetValues(typeof(QuestionFixNum.TAG_NAME))){
                    tag[(int)tag_name] = doc.CreateElement((tag_name.ToString()).ToLower());
                }
#endif

                // qm[hǉ̂߂̐evfݒ(examinations)
#if ONEONE
                this.doc.AppendChild(layer_ex);

                // g񂵗p
                choiceEleTemp = new XmlElement[4];
#else
                doc.AppendChild(tag[(int)QuestionFixNum.TAG_NAME.EXAMINATIONS]);
#endif
                // Xg̑SIuWFNg̒lem[hɐݒ
                foreach (Question1Select4Answer temp_q1s4a in this.lstQuestionData)
                {
#if ONEONE
                    // XMLm[hǉ([gAAÁAIx4AA)
                    layer_exTemp = (XmlElement)layer_ex.Clone();
                    examinationEleTemp = (XmlElement)examinationEle.Clone();
                    questionEleTemp = (XmlElement)questionEle.Clone();
                    sentenceEleTemp = (XmlElement)sentenceEle.Clone();
                    choiceEleTemp[0] = (XmlElement)choiceEle[0].Clone();
                    choiceEleTemp[1] = (XmlElement)choiceEle[1].Clone();
                    choiceEleTemp[2] = (XmlElement)choiceEle[2].Clone();
                    choiceEleTemp[3] = (XmlElement)choiceEle[3].Clone();
                    answerEleTemp = (XmlElement)answerEle.Clone();
                    categoryEleTemp = (XmlElement)categoryEle.Clone();
#else
                    for (int i = 0; i < (int)QuestionFixNum.TAG_NAME.TAG_NAME_NUM; i++){
                        tagClone[i] = (XmlElement)tag[i].Clone();
                    }
#endif
                    ////tag[(int)QuestionFixNum.TAG_NAME.EXAMINATION].SetAttributeNode(QuestionFixNum.NODE_YEAR, temp_q1s4a.Year.ToString());
                    // lݒ(oNAA敪Aԍ)
                    examinationEleTemp.SetAttribute(QuestionFixNum.NODE_YEAR, temp_q1s4a.Year.ToString());
                    examinationEleTemp.SetAttribute(QuestionFixNum.NODE_SEASON, temp_q1s4a.Season);
                    examinationEleTemp.SetAttribute(QuestionFixNum.NODE_TIME, temp_q1s4a.TimeDiv.ToString());
                    questionEleTemp.SetAttribute(QuestionFixNum.NODE_NO, temp_q1s4a.QuestionNo.ToString());

                    // vfeݒ(́AIx4AA)
                    sentenceEleTemp.InnerText = temp_q1s4a.Sentence;
                    choiceEleTemp[0].InnerText = temp_q1s4a.Choices[0];
                    choiceEleTemp[1].InnerText = temp_q1s4a.Choices[1];
                    choiceEleTemp[2].InnerText = temp_q1s4a.Choices[2];
                    choiceEleTemp[3].InnerText = temp_q1s4a.Choices[3];
                    answerEleTemp.InnerText = temp_q1s4a.Answer.ToString();
                    categoryEleTemp.InnerText = temp_q1s4a.Category;

                    XmlNodeList xnl = this.doc.SelectNodes(QuestionFixNum.EXAMINATIONS_LAYER);

                    // XMLo^Ƃ
                    if (xnl.Count != 0)
                    {
                        // Kwݒ
                        xnl[0].AppendChild(examinationEleTemp);
                        examinationEleTemp.AppendChild(questionEleTemp);
                        questionEleTemp.AppendChild(sentenceEleTemp);
                        questionEleTemp.AppendChild(choiceEleTemp[0]);
                        questionEleTemp.AppendChild(choiceEleTemp[1]);
                        questionEleTemp.AppendChild(choiceEleTemp[2]);
                        questionEleTemp.AppendChild(choiceEleTemp[3]);
                        questionEleTemp.AppendChild(answerEleTemp);
                        questionEleTemp.AppendChild(categoryEleTemp);
                    }
                }

                // t@Cւ̍쐬
                tw = new XmlTextWriter(this.file_path, Encoding.UTF8);
                if (tw != null)
                {
                    tw.Formatting = Formatting.Indented;
                    this.doc.WriteContentTo(tw);
                }
            }
            catch (Exception ex)
            {
                // t@CbNĂ/foCXɏݕs\̏ꍇ
                throw ex;
            }
            finally
            {
                if (tw != null)
                {
                    tw.Close();

                    // IuWFNg̃XgSm[hf[^
                    this.lstQuestionData.Clear();
                }
            }
        }
        #endregion

        #region private\bh
        /// <summary>
        /// XMLt@Cǂݍރ\bhłB
        /// </summary>
        /// <returns>XmlDocument^@XMLf[^i[t@Cǂݍ񂾃hLg̒lԂ܂B</returns>
        private XmlDocument LoadXmlDocument()
        {
            XmlReader reader = null;
            XmlDocument doc;
            try
            {
                reader = XmlReader.Create(this.file_path);
                doc = new XmlDocument();
                doc.Load(reader);
            }
            catch (Exception ex)
            {
                // t@CbNĂꍇ
                throw ex;
            }
            finally
            {
                if (reader != null)
                {
                    reader.Close();
                }
            }

            return doc;
        }

        /// <summary>
        /// ̎擾`FbN܂B
        /// </summary>
        /// <param name="array">_̒ŉԂ̒l擾Ă܂B</param>
        /// <param name="now">`FbNĂCfbNX̒lłB</param>
        /// <param name="num">擾̒lłB</param>
        private void CheckSameNum(int[] array, int now, int num)
        {
            Random random = new System.Random();    // _̎평
            int breakFlg = 0;                       // 擾ă[vptO

            while (true)
            {
                // vf̒ǂꂩ擾
                array[now] = random.Next(this.lstQuestionData.Count);
                breakFlg = 0;

                // l̏ꍇ͂񗐐Ȃ
                for (int checkLoop = 0; checkLoop < now; checkLoop++)
                {
                    if (array[checkLoop] == array[now])
                    {
                        breakFlg = 1;
                        break;
                    }
                }

                if (breakFlg != 1)
                {
                    break;
                }
            }
        }

        #endregion
    }
}
