//-----------------------------------------------------------------------
// <copyright file="EndRequimentConfigure.cs">
// </copyright>
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using UserControlLibrary;

namespace Gui
{
    /// <summary>
    /// Iݒ肵܂B
    /// </summary>
    public partial class EndRequimentConfigure : Form
    {
        #region tB[h
        /// <summary>
        /// ԕ`܂B
        /// </summary>
        private const string LIMIT_TIME = "";

        /// <summary>
        /// 萔`܂B
        /// </summary>
        private const string QUESTION_NUMBER = "萔";
        #endregion

        #region RXgN^
        /// <summary>
        /// RXgN^
        /// </summary>
        public EndRequimentConfigure()
        {
            // R|[lg
            this.InitializeComponent();

            // Ԃ͔͈̓͂̏
            this.fcbLimitTime.InputScope = new InputScope(1, 99);
            this.fcbLimitTime.DisabledKeys.Add((int)Keys.Delete);
            this.fcbLimitTime.DisabledKeys.Add((int)Keys.Space);

            // 萔͔͈̓͂̏
            this.fcbQuestionNumber.InputScope = new InputScope(1, 99);
            this.fcbQuestionNumber.DisabledKeys.Add((int)Keys.Delete);
            this.fcbQuestionNumber.DisabledKeys.Add((int)Keys.Space);

            // Ԃ̑ICfbNXύX
            this.fcbLimitTime.SelectedIndex = Gui.Properties.Settings.Default.LimitTime - 1;

            // 萔̑ICfbNXύX
            this.fcbQuestionNumber.SelectedIndex = Gui.Properties.Settings.Default.QuestionNumberSum - 1;
        }
        #endregion

        #region Cxgnh
        /// <summary>
        /// o胂[hIփ{^NbNꂽ
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void btnToModeSelect_Click(object sender, EventArgs e)
        {
            try
            {
                // 錾
                DialogResult dlr;   // _CAO

                // bZ[W\
                dlr = MessageBox.Show(Gui.Properties.Message2.C_001, Gui.Properties.MessageTitle2.T_002, MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (dlr == DialogResult.Yes)
                {
                    // ̉ʂ
                    this.Close();
                }
            }
            catch (Exception exc)
            {
                // bZ[W{bNX\
                MessageBox.Show(exc.ToString());
            }
        }

        /// <summary>
        /// ݒ{^NbNꂽ
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void btnConfigure_Click(object sender, EventArgs e)
        {
            try
            {
                if (this.fcbLimitTime.Text == String.Empty)
                {
                    // bZ[W\
                    MessageBox.Show(String.Format(Gui.Properties.Message2.E_001, LIMIT_TIME), Gui.Properties.MessageTitle2.T_004, MessageBoxButtons.OK, MessageBoxIcon.Error);

                    // G[I
                    return;
                }
                else if (this.fcbQuestionNumber.Text == String.Empty)
                {
                    // bZ[W\
                    MessageBox.Show(String.Format(Gui.Properties.Message2.E_001, QUESTION_NUMBER), Gui.Properties.MessageTitle2.T_004, MessageBoxButtons.OK, MessageBoxIcon.Error);

                    // G[I
                    return;
                }
                else
                {
                    // Ԃݒ
                    Gui.Properties.Settings.Default.LimitTime = int.Parse(this.fcbLimitTime.Text);

                    // 萔ݒ
                    Gui.Properties.Settings.Default.QuestionNumberSum = int.Parse(this.fcbQuestionNumber.Text);

                    // vpeBۑ
                    Gui.Properties.Settings.Default.Save();

                    // bZ[W\
                    MessageBox.Show(Gui.Properties.Message2.N_002, Gui.Properties.MessageTitle2.T_006);

                    // ̉ʂ
                    this.Close();
                }
            }
            catch (Exception exc)
            {
                // bZ[W{bNX\
                MessageBox.Show(exc.ToString());
            }
        }
        #endregion
    }
}