//-----------------------------------------------------------------------
// <copyright file="InputScopeConverter.cs">
// </copyright>
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace UserControlLibrary
{
    /// <summary>
    /// ͔͈͂ݒ肷ۂ̃Ro[^łB
    /// </summary>
    public class InputScopeConverter : ExpandableObjectConverter
    {
        #region public\bh
        /// <summary>
        /// Ro[^Aw肵ReLXggpāAw肵^ɃIuWFNgϊł邩ǂlԂ܂B 
        /// </summary>
        /// <param name="context">wReLXg񋟂 ITypeDescriptorContext i[܂B</param>
        /// <param name="destinationType">ϊ̌^i[܂B</param>
        /// <returns>Ro[^ϊsłꍇ trueBȊȌꍇ falseԂ܂B</returns>
        public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
        {
            // ^͔͈͂ƈvȂ
            if (destinationType == typeof(InputScope))
            {
                return true;
            }

            // {NX̖߂lԂ
            return base.CanConvertTo(context, destinationType);
        }

        /// <summary>
        /// w肵ReLXgƃJ`gpāAw肵lIuWFNgAw肵^ɕϊ܂B
        /// </summary>
        /// <param name="context">wReLXg񋟂 ITypeDescriptorContext i[܂B</param>
        /// <param name="culture">݂̃J`ƂĎgp CultureInfo i[܂B</param>
        /// <param name="value">ϊΏۂi[܂B</param>
        /// <param name="destinationType">ϊ̌^\܂B</param>
        /// <returns>ϊ̒l\IuWFNgԂ܂B</returns>
        public override object ConvertTo(ITypeDescriptorContext context, System.Globalization.CultureInfo culture, object value, Type destinationType)
        {
            // ^^͔͈͂֘AȂ
            if (destinationType == typeof(string) && value is InputScope)
            {
                InputScope ips = (InputScope)value;
                return ips.Start + ", " + ips.End;
            }

            // {NX̖߂lԂ
            return base.ConvertTo(context, culture, value, destinationType);
        }

        /// <summary>
        /// Ro[^̌^̃IuWFNgRo[^̌^ɕϊł邩ǂlԂ܂B
        /// </summary>
        /// <param name="context">wReLXg񋟂 ITypeDescriptorContext i[܂B</param>
        /// <param name="sourceType">ϊ̌^\܂B</param>
        /// <returns>Ro[^ϊsłꍇ trueBȊȌꍇ falseԂ܂B</returns>
        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
        {
            // ^^ƈvȂ
            if (sourceType == typeof(string))
            {
                return true;
            }

            // {NX̖߂lԂ
            return base.CanConvertFrom(context, sourceType);
        }

        /// <summary>
        /// w肵ReLXgƃJ`gpāAw肵IuWFNgRo[^̌^ɕϊ܂B 
        /// </summary>
        /// <param name="context">wReLXg񋟂 ITypeDescriptorContext i[܂B</param>
        /// <param name="culture">݂̃J`ƂĎgp CultureInfo i[܂B</param>
        /// <param name="value">ϊΏۂi[܂B</param>
        /// <returns>ϊ̒l\IuWFNgԂ܂B</returns>
        public override object ConvertFrom(ITypeDescriptorContext context, System.Globalization.CultureInfo culture, object value)
        {
            if (value is string)
            {
                if (context.PropertyDescriptor.PropertyType == typeof(InputScope))
                {
                    try
                    {
                        string[] item = ((string)value).Split(",".ToCharArray());

                        InputScope ips = new InputScope(int.Parse(item[0]), int.Parse(item[1]));
                        return ips;
                    }
                    catch
                    {
                        throw new ArgumentException(" '" + (string)value + "'  InputScope ^ɕϊł܂");
                    }
                }
            }

            // {NX̖߂lԂ
            return base.ConvertFrom(context, culture, value);
        }

        /// <summary>
        /// w肵ReLXggpāAIuWFNgvpeBT|[gĂ邩ǂl擾܂B
        /// </summary>
        /// <param name="context">wReLXg񋟂 ITypeDescriptorContext i[܂B</param>
        /// <returns>̃IuWFNg̃vpeB邽߂ GetProperties ĂяoKv̂ŁAtrueԂ܂B</returns>
        public override bool GetPropertiesSupported(ITypeDescriptorContext context)
        {
            if (context.PropertyDescriptor.PropertyType == typeof(InputScope))
            {
                return true;
            }

            return base.GetPropertiesSupported(context);
        }

        /// <summary>
        /// value p[^Ɏw肳ꂽIuWFNg^̃vpeB̃RNV擾܂B
        /// </summary>
        /// <param name="context">wReLXg񋟂 ITypeDescriptorContext i[܂B</param>
        /// <param name="value">vpeB擾ΏۂƂȂIuWFNǧ^i[܂B</param>
        /// <param name="attributes">tB^ƂĎgpAAttribute ^̔złB</param>
        /// <returns>w肳ꂽR|[lgɑ΂ČJĂvpeBi[Ă PropertyDescriptorCollection Ԃ܂B</returns>
        public override PropertyDescriptorCollection GetProperties(ITypeDescriptorContext context, object value, Attribute[] attributes)
        {
            if (context.PropertyDescriptor.PropertyType == typeof(InputScope))
            {
                PropertyDescriptorCollection pdc = TypeDescriptor.GetProperties(value, attributes);
                string[] propertyOrder = { "Start", "End" };
                return pdc.Sort(propertyOrder);
            }

            return base.GetProperties(context, value, attributes);
        }
        #endregion
    }
}
