//==============================================
// OtBbNX\ [graphics.cpp]
//==============================================
#include "../head/graphics.h"

//******************************
// O[oϐ
//******************************
LPDIRECT3D9				g_pD3D = NULL;				// Direct3DIuWFNg
LPDIRECT3DDEVICE9		g_pD3DDevice = NULL;		// DeviceIuWFNg(`ɕKv)
LPD3DXFONT				g_pD3DXFont = NULL;			// tHgIuWFNg(tHg)
LPD3DXFONT				g_pD3DXFont_title = NULL;			// tHgIuWFNg(tHg)
LPD3DXFONT				g_pD3DXFont_val = NULL;			// tHgIuWFNg(tHg)
LPD3DXFONT				g_pD3DXFont_normal = NULL;			// tHgIuWFNg(tHg)
LPD3DXFONT				g_pD3DXFont_stgld = NULL;			// tHgIuWFNg(tHg)


//==============================
// 
//==============================
HRESULT InitGraphics(HWND hWnd, BOOL bWindow)
{
	D3DPRESENT_PARAMETERS d3dpp;
    D3DDISPLAYMODE d3ddm;

	// Direct3DIuWFNg̍쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if(g_pD3D == NULL)
	{
		return E_FAIL;
	}

	// ݂̃fBXvC[h擾
    if(FAILED(g_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3ddm)))
	{
		return E_FAIL;
	}

	// foCX̃v[e[Vp[^̐ݒ
	ZeroMemory(&d3dpp, sizeof(d3dpp));							// [N[NA
	d3dpp.BackBufferCount			= 1;						// obNobt@̐
	d3dpp.BackBufferWidth			= SCREEN_WIDTH;				// Q[ʃTCY()
	d3dpp.BackBufferHeight			= SCREEN_HEIGHT;			// Q[ʃTCY()
	d3dpp.BackBufferFormat			= D3DFMT_UNKNOWN;			// obNobt@̃tH[}bg͌ݐݒ肳Ă̂g
	d3dpp.SwapEffect				= D3DSWAPEFFECT_DISCARD;	// fMɓătbv
	d3dpp.Windowed					= bWindow;					// EBhE[h
	d3dpp.EnableAutoDepthStencil	= TRUE;						// fvXobt@iyobt@jƃXeVobt@쐬
	d3dpp.AutoDepthStencilFormat	= D3DFMT_D16;				// fvXobt@Ƃ16bitg
	d3dpp.BackBufferFormat			= d3ddm.Format;				// J[[h̎w

	if(bWindow)
	{// EBhE[h
		d3dpp.BackBufferFormat           = D3DFMT_UNKNOWN;					// obNobt@
		d3dpp.FullScreen_RefreshRateInHz = 0;								// tbV[g
		d3dpp.PresentationInterval       = D3DPRESENT_INTERVAL_IMMEDIATE;	// C^[o
	}
	else
	{// tXN[[h
		d3dpp.BackBufferFormat           = D3DFMT_R5G6B5;					// obNobt@
		d3dpp.FullScreen_RefreshRateInHz = D3DPRESENT_RATE_DEFAULT;			// tbV[g
		d3dpp.PresentationInterval       = D3DPRESENT_INTERVAL_DEFAULT;		// C^[o
	}

	// foCX̐
	// fBXvCA_v^\߂̃foCX쐬
	// `ƒ_n[hEFAōsȂ
	if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT,							// fBXvCA_v^
									D3DDEVTYPE_HAL,								// fBXvC^Cv
									hWnd,										// tH[JXEChEւ̃nh
									D3DCREATE_HARDWARE_VERTEXPROCESSING,		// foCX쐬̑gݍ킹
									&d3dpp,										// foCX̃v[e[Vp[^
									&g_pD3DDevice)))							// foCXC^[tF[Xւ̃|C^
	{
		// L̐ݒ肪s
		// `n[hEFAōsA_CPUōsȂ
		if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, 
										D3DDEVTYPE_HAL, 
										hWnd, 
										D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
										&d3dpp,
										&g_pD3DDevice)))
		{
			// L̐ݒ肪s
			// `ƒ_CPUōsȂ
			if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, 
											D3DDEVTYPE_REF,
											hWnd, 
											D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
											&d3dpp,
											&g_pD3DDevice)))
			{
				// s
				return E_FAIL;
			}
		}
	}

	// _OXe[gp[^̐ݒ
    g_pD3DDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);				// JOsȂ
	g_pD3DDevice->SetRenderState(D3DRS_ZENABLE, TRUE);						// Zobt@gp
	g_pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);				// uhs
	g_pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);		// \[XJ[̎w
	g_pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);	// fXeBl[VJ[̎w

	// Tv[Xe[gp[^̐ݒ
	g_pD3DDevice->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP);	// eNX`tľJԂݒ
	g_pD3DDevice->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP);	// eNX`uľJԂݒ
	g_pD3DDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_NONE);	// eNX`g厞̕Ԑݒ
	g_pD3DDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_NONE);	// eNX`k̕Ԑݒ

	// At@`lL
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE); 

	// tHgݒ(18|CgAtHgulr SVbNv)
	// {tHg = SHIFTJIS_CHARSET, tHg = DEFAULT_CHARSET
	D3DXCreateFont(g_pD3DDevice, 18, 0, 0, 0, FALSE, SHIFTJIS_CHARSET,  //
					OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, _T("lr SVbN"), &g_pD3DXFont);

	D3DXCreateFont(g_pD3DDevice, 108, 0, 0, 0, FALSE, SHIFTJIS_CHARSET, //^Cg
					OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, _T("HGnpp߯ߑ"), &g_pD3DXFont_title);

	D3DXCreateFont(g_pD3DDevice, 72, 0, 0, 0, FALSE, SHIFTJIS_CHARSET,  //_ƃXs[h̐
    				OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, _T("Leelawadee"), &g_pD3DXFont_val);

	D3DXCreateFont(g_pD3DDevice, 36, 0, 0, 0, FALSE, SHIFTJIS_CHARSET,  //_ƃXs[h̕A^CgIA
    				OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, _T("Leelawadee"), &g_pD3DXFont_normal);

	D3DXCreateFont(g_pD3DDevice, 18, 0, 0, 0, FALSE, SHIFTJIS_CHARSET,  //Ƃ
    				OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, _T("Leelawadee"), &g_pD3DXFont_stgld);
    

	return S_OK;
}

//==============================
// I
//==============================
void UninitGraphics(void)
{
	// XvCg̏I
	SAFE_RELEASE(g_pD3DXFont);			// tHg̉
	SAFE_RELEASE(g_pD3DXFont_title);			// tHg̉
	SAFE_RELEASE(g_pD3DXFont_val);			// tHg\
	SAFE_RELEASE(g_pD3DXFont_normal);			// tHg\
	SAFE_RELEASE(g_pD3DXFont_stgld);			// tHg̉

	SAFE_RELEASE(g_pD3DDevice);			// foCX̉
	SAFE_RELEASE(g_pD3D);				// Direct3DIuWFNg̉
}

