//-----------------------------------------------------------------------
// <copyright file="Choice.cs">
// </copyright>
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace UserControlLibrary
{
    /// <summary>
    /// Ĩ[URg[łB
    /// </summary>
    public partial class Choice : UserControl
    {
        #region tB[h
        /// <summary>
        /// `܂B
        /// </summary>
        private const string RIGHT = "";

        /// <summary>
        /// 듚`܂B
        /// </summary>
        private const string WRONG = "~";

        /// <summary>
        /// tOi[܂B
        /// </summary>
        private bool bolRightAnswer;

        /// <summary>
        /// 냉xi[܂B
        /// </summary>
        private Label lblRightOrWrong;
        #endregion

        #region RXgN^
        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="kataId">J^JiIDi[܂B</param>
        public Choice(string kataId)
        {
            // 냉x
            this.lblRightOrWrong = new Label();
            this.lblRightOrWrong.AutoSize = true;
            this.lblRightOrWrong.Font = new Font("MS UI Gothic", 72F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)128));
            this.lblRightOrWrong.Location = new Point(10, 20);
            this.lblRightOrWrong.Visible = false;

            // R|[lg
            this.InitializeComponent();

            // 냉xߏ
            this.lblRightOrWrong.BackColor = Color.Transparent;
            this.lblRightOrWrong.Location = new Point(0, 20);
            this.lblSentence.Controls.Add(this.lblRightOrWrong);

            // J^JiIDɑ
            this.lblKataId.Text = kataId;

            // tO
            this.bolRightAnswer = false;
        }
        #endregion

        #region vpeB
        /// <summary>
        /// 𓚕\tO擾yѐݒ肵܂B
        /// </summary>
        public bool ShowedAnswer
        {
            get { return this.lblRightOrWrong.Visible; }
            set { this.lblRightOrWrong.Visible = value; }
        }

        /// <summary>
        /// `FbNtO擾yѐݒ肵܂B
        /// </summary>
        public bool Checked
        {
            get { return this.chbChoice.Checked; }
            set { this.chbChoice.Checked = value; }
        }

        /// <summary>
        /// J^JiID擾yѐݒ肵܂B
        /// </summary>
        public string KataId
        {
            get { return this.lblKataId.Text; }
        }

        /// <summary>
        /// I擾yѐݒ肵܂B
        /// </summary>
        public string Sentence
        {
            get { return this.lblSentence.Text; }
            set { this.lblSentence.Text = value; }
        }

        /// <summary>
        /// tO擾yѐݒ肵܂B
        /// </summary>
        public bool RightAnswer
        {
            get
            {
                // tOԂ
                return this.bolRightAnswer;
            }

            set
            {
                // 냉x
                if (value)
                {
                    this.lblRightOrWrong.ForeColor = Color.Red;
                    this.lblRightOrWrong.Text = RIGHT;
                }
                else
                {
                    this.lblRightOrWrong.ForeColor = Color.Blue;
                    this.lblRightOrWrong.Text = WRONG;
                }

                // tOɑ
                this.bolRightAnswer = value;
            }
        }
        #endregion

        #region Cxgnh
        /// <summary>
        /// `FbN{bNXAJ^JiIDxAIxNbNꂽ
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void ControlClick(object sender, EventArgs e)
        {
            // Cxg𔭐M
            this.OnClick(e);
        }
        #endregion
    }
}
